<template>
  <div class="prefix">Select a feature to compare</div>
  <div class="select">
    <div class="toggler" @click="isOpen = !isOpen">
      <div>{{modelValue.label}}</div>
    <div v-if="isOpen" class="icon">
      <svg viewBox="0 0 24 24"><path :d="mdiChevronUp" /></svg>
    </div>
      <div v-else class="icon">
        <svg viewBox="0 0 24 24"><path :d="mdiChevronDown" /></svg>
      </div>
    </div>
    <div class="options" v-if="isOpen">
      <div v-for="option in options" :key="option.id" @click="selectOption(option)">
        <div :class="['option', { 'active': option.label === modelValue.label }]">
          {{option.label}}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { ref } from 'vue'
import { mdiChevronUp, mdiChevronDown } from '@mdi/js'

export default {
  name: 'Select',
  props: {
    options: {
      type: Array,
      required: true
    },
    modelValue: {
      type: Object,
      required: true
    }
  },
  setup(props, { emit }) {
    const isOpen = ref(false)
    function selectOption(option) {
      isOpen.value = false
      emit('update:modelValue', option)
    }

    return { isOpen, selectOption, mdiChevronUp, mdiChevronDown }
  }
}
</script>

<style scoped>
.select {
  display: flex;
  align-items: center;
  font-size: 0.875rem;
  position: relative;
  color: #4e5e77;
}

.prefix {
  display: flex;
  align-items: center;
  margin-right: 0.5rem;
  color: #4e5e77;
}

.toggler {
  display: flex;
  justify-content: space-between;
  align-items: center;
  border: 0.0625rem #939ab4 solid;
  cursor: pointer;
  width: 8rem;
  padding: 0.125rem 1rem;
}

.options {
  position: absolute;
  top: 2.125rem;
  display: flex;
  flex-direction: column;
  border: 0.0625rem #939ab4 solid;
  width: 10rem;
  background: white;
}

.option {
  padding: 0.25rem 1rem;
  cursor: pointer;
}

.option:hover {
  background-color: #eceffd;
}

.active {
  background-color: #ccd8ff;
}

.icon {
  width: 1rem;
}
</style>